package com.ozs.web.controller.common;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ozs.common.core.domain.AjaxResult;
import com.ozs.common.utils.ApiTokenUtils;
import com.ozs.common.utils.MinioUtils;
import com.ozs.common.utils.uuid.IdUtils;
import com.ozs.service.entity.BaseCameraManagement;
import com.ozs.service.entity.MsgAlarm;
import com.ozs.service.service.BaseCameraManagementService;
import com.ozs.service.service.MsgAlarmService;
import com.ozs.service.service.impl.CameraCaptureService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.List;

/**
 * @author wyy
 * @subject
 * @creat 2023/4/18
 */
@RestController
@RequestMapping("/getPicture")
public class PictureController {
    private static final Logger log = LoggerFactory.getLogger(PictureController.class);
    @Resource
    private ApiTokenUtils apiTokenUtils;
    @Resource
    BaseCameraManagementService baseCameraManagementService;
    @Resource
    MsgAlarmService msgAlarmService;
    @Resource
    CameraCaptureService cameraCaptureService;

    /**
     * 获取图片
     *
     * @param
     * @return
     */
    @PostMapping("/api/snap")
    public AjaxResult getPicture() throws IOException {
        List<BaseCameraManagement> list = baseCameraManagementService.list();
        list.forEach(l -> {
            String uuid = IdUtils.fastSimpleUUID();
            if(!ObjectUtils.isEmpty(l.getCameraCode()) &&!ObjectUtils.isEmpty(l.getChannel())){
                QueryWrapper<MsgAlarm> queryWrapper = new QueryWrapper<MsgAlarm>();
                queryWrapper.lambda().eq(MsgAlarm::getCameraCode,l.getCameraCode());
                queryWrapper.lambda().eq(MsgAlarm::getIsLock,2);
                List<MsgAlarm> msgAlarmList = msgAlarmService.list(queryWrapper);
                try {
                    System.out.println("http://124.70.58.209:18891/snap/"+l.getCameraCode()+"/"+l.getChannel());
                    log.info("请求url"+"http://124.70.58.209:18891/snap/"+l.getCameraCode()+"/"+l.getChannel());
                    URL url = new URL("http://124.70.58.209:18891/snap/"+l.getCameraCode()+"/"+l.getChannel());
                    String fileName = "cameraPicture/"+l.getCameraCode()+"_"+uuid +".jpg";
                    log.info("fileName="+fileName);
                    cameraCaptureService.getCapture(url, fileName);
                } catch (MalformedURLException e) {
                    e.printStackTrace();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });
        return AjaxResult.success(list);
    }
}
